package ru.dbotthepony.mc.otm.menu.widget

import mekanism.api.functions.FloatSupplier
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import java.util.function.BooleanSupplier

@Suppress("unused")
class ProgressGaugeWidget(menu: MatteryMenu) {
	var progressSupplier: FloatSupplier = FloatSupplier { 0f }
	var stuckSupplier: BooleanSupplier = BooleanSupplier { false }

	val percentage by menu.mSynchronizer.ComputedFloatField(getter = { progressSupplier.asFloat })
	val isStuck by menu.mSynchronizer.ComputedBooleanField(getter = { stuckSupplier.asBoolean })

	constructor(
		menu: MatteryMenu,
		progress: FloatSupplier
	) : this(menu) {
		this.progressSupplier = progress
	}

	constructor(
		menu: MatteryMenu,
		progress: FloatSupplier,
		stuck: BooleanSupplier,
	) : this(menu) {
		this.progressSupplier = progress
		this.stuckSupplier = stuck
	}

	fun with(progress: FloatSupplier): ProgressGaugeWidget {
		this.progressSupplier = progress
		this.stuckSupplier = BooleanSupplier { false }
		return this
	}

	fun with(progress: FloatSupplier, stuck: BooleanSupplier): ProgressGaugeWidget {
		this.progressSupplier = progress
		this.stuckSupplier = stuck
		return this
	}
}
